/***************************************************************************
 *   Copyright (C) 2007 by Stefan Lau   *
 *   stefan.lau@gmx.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef __WIN32__
	#define Win 1
#else
	#define Win 0
#endif

#ifndef __ADDPROFILE_H__
#define __ADDPROFILE_H__

#include "mainwindowimpl.h"
#include "ui_addprofile.h"
#include "def.h"
#include <QtGui>
#include <QFtp>

class AddProfileImpl : public QDialog, public Ui::AddProfile
{
Q_OBJECT
public:
	AddProfileImpl(MainWindowImpl *Parent_f);
	
	void SetupCaptionsAndIcons();
	
	bool Accepted;
	
	OProfile *NewProfile;

	MainWindowImpl *Parent;
private:
	QFtp FTP;	
	
	QList<QTreeWidgetItem*> LocalItems;
	QList<QTreeWidgetItem*> ServerItems;
private slots:
	void NextButton();
	void BackButton();
	void CancelButton();
	
	void BaseDirLocalSeekButton();
	void BaseDirServerSeekButton();
	
	void LW_OtherProfile_RowChanged(int NewRow);

	void AddFileButton();
	void RemoveFileButton();
	
	void CB_CheckForMDTM_Changed(int ChangedTo);
	void CB_CheckForSize_Changed(int ChangedTo);
		
	void ListFiles();
	void TW_ServerChanged(QTreeWidgetItem *Current, int Column);
	void TW_LocalChanged(QTreeWidgetItem *Current, int Column);
	
	void CheckFTP(bool Error);
	void ftp_commandFinished();
};
#endif // __ADDPROFILE_H__
