/***************************************************************************
 *   Copyright (C) 2007 by Stefan Lau   *
 *   stefan.lau@gmx.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef __WIN32__
	#define Win 1
#else
	#define Win 0
#endif

#ifndef __BROWSEFTPIMPL_H__
#define __BROWSEFTPIMPL_H__

#include "ui_browseftp.h"
#include "def.h"
#include <QFtp>
#include <QtGui>

class BrowseFTPImpl : public QDialog, public Ui::BrowseFTP
{
Q_OBJECT
public:
	BrowseFTPImpl(OProfile *Profile_f, QString Filename = "", bool SelectDirectory_f = 0);
	
	QString Result;
	OProfile *Profile;
	
	void SetupCaptionsAndIcons();
private:
	QFtp FTP;
	int pos;
	
	QStringList Previous;
	QStringList Forward;
	QString Current;
	bool SelectDirectory;
	QList<bool> isDirectory; 
		
private slots:
	void Connect(OProfile *Profile_f);
	void List();
	void FTPList(QUrlInfo Url);
	void ListWidgedItemDoubleClicked(QListWidgetItem *item);
	void ListWidgedItemClicked(QListWidgetItem *item);
	void ChangeDir(QString Directory, bool Direct, bool History);
	
	void PreviousButton();
	void ForwardButton();
	void UpButton();
	void SetupButtons();
	void NewDirButton();
	
	void OkButton();
	
	void ftp_commandFinished();
	void ftp_done(bool error);
	
};

#endif // __BROWSEFTPIMPL_H__
