#include "def.h"

OFileConnection::OFileConnection() {
	ExistsLocal = 1;
	ExistsServer = 1;
	
	New = 1;
}

OFileConnection::OFileConnection(const OFileConnection& FC) {
	this->ServerFile = FC.ServerFile;
	this->LocalFile = FC.LocalFile;
	this->LocalWidgetItem = FC.LocalWidgetItem;
	this->ServerWidgetItem = FC.ServerWidgetItem;
}

OFileConnection::OFileConnection(QString LocalFile_f, QString ServerFile_f) {
	this->LocalFile = LocalFile_f;
	this->ServerFile = ServerFile_f;
}

OProfile::OProfile() {
	this->Server = "";
	this->Username = "";
	this->Password = "";
	this->ServerBaseDir = "/";
	this->LocalBaseDir = "/";
	this->CheckForMDTM = 0;
	this->CheckForSize = 0;

	this->TimeDifference = 0;
}

OProfile::OProfile(const OProfile& P) {
	this->Server = P.Server;
	this->Username = P.Username;
	this->Password = P.Password;
	this->ServerBaseDir = P.ServerBaseDir;
	this->LocalBaseDir = P.LocalBaseDir;
	this->CheckForMDTM = P.CheckForMDTM;
	this->CheckForSize = P.CheckForSize;
	
	this->TimeDifference = 0;

	for (int i=0;i<(signed)P.Files.size();i++) this->Files.push_back(P.Files[i]);
}

std::vector<OFileConnection*> OProfile::LookForServerFile(QString ServerFilef) {
	std::vector<OFileConnection*> Result;
	std::vector<OFileConnection*>::iterator i = Files.begin();
		for (;i < this->Files.end();i++)
			if ((*i)->ServerFile == ServerFilef)
				Result.push_back((*i));
return Result;
}

std::vector<OFileConnection*>  OProfile::LookForLocalFile(QString LocalFile) {
std::vector<OFileConnection*> Result;
std::vector<OFileConnection*>::iterator i = Files.begin();
	for (;i < this->Files.end();i++)
		if ((*i)->LocalFile == LocalFile)
			Result.push_back((*i));
return Result;	
}

std::vector<OFileConnection*> OProfile::LookForServerWidgetItem(QTreeWidgetItem *Item) {
std::vector<OFileConnection*> Result;
std::vector<OFileConnection*>::iterator i = Files.begin();
	for (;i < this->Files.end();i++)
		if ((*i)->ServerWidgetItem == Item)
			Result.push_back((*i));
return Result;	
}

std::vector<OFileConnection*> OProfile::LookForLocalWidgetItem(QTreeWidgetItem *Item) {
std::vector<OFileConnection*> Result;
std::vector<OFileConnection*>::iterator i = Files.begin();
	for (;i < this->Files.end();i++)
		if ((*i)->LocalWidgetItem == Item)
			Result.push_back((*i));
return Result;	
}

OFileConnection* OProfile::LookForWidgetItems(QTreeWidgetItem *Local, QTreeWidgetItem *Server) {
std::vector<OFileConnection*> Result;
std::vector<OFileConnection*>::iterator i = Files.begin();
	for (;i < this->Files.end();i++)
		if ((*i)->LocalWidgetItem == Local && (*i)->ServerWidgetItem == Server)
			return (*i);
return NULL;	
}

bool OProfile::DeleteConnection(QTreeWidgetItem *LocalItem, QTreeWidgetItem *ServerItem) {
std::vector<OFileConnection*>::iterator i = Files.begin();
for (;i < Files.end(); i++) {
	if ((*i)->LocalWidgetItem == LocalItem && (*i)->ServerWidgetItem == ServerItem) {
		delete *i;
		Files.erase(i);
		return 1;
	}
}
return 0;
}
