/***************************************************************************
 *   Copyright (C) 2007 by Stefan Lau   *
 *   stefan.lau@gmx.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef __WIN32__
	#define Win 1
#else
	#define Win 0
#endif

#ifndef __UPDATEFILESTATUSDIALOGIMPL_H__
#define __UPDATEFILESTATUSDIALOGIMPL_H__
 
#include "ui_updatefilestatus.h"
#include "def.h"
#include <vector>
#include <QtGui>
#include <QFtp>
#include <QFile>
#include <QDir>
//
class UpdateFileStatusDialogImpl : public QDialog, public Ui::UpdateFileStatusDialog
{
Q_OBJECT
public:
	UpdateFileStatusDialogImpl(OProfile *Profile_f, QString ProxyIP, QString ProxyPort, std::vector<OFileConnection*> = std::vector<OFileConnection*>());
	void SetupCaptionsAndIcons();

	bool Accepted;
private:
	OProfile *Profile;
	std::vector<OFileConnection*> FilesToProcess;
	QFtp *FTP;
	
	int CurrentFile;
	int SizeFile;

	bool KeepOpen;

	bool FileNotFound;
	void GoOn();
private slots:
	void LocalInformation();
	void ServerInformation();
	void done(bool);

	void PB_Cancel_clicked();
public slots:
	void rawCommandReply(int, QString);
};

#endif
